#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <pwd.h>
#include <grp.h>
#include <fcntl.h>
#include <sys/stat.h>

static int fstatat_with_fallback_user (int __fd, const char *__restrict __file,
		    struct stat *__restrict __buf, int __flag) {
	int rst;
	rst = fstatat(__fd, __file, __buf, __flag);
	if (rst >= 0) {
		return rst;
	}

	char *current_task_user = getenv("CURRENT_TASK_USER");
    current_task_user = "cloudam";
    if (current_task_user == NULL) {
         // fprintf(stderr, "Error: no env CURRENT_TASK_USER '%s'\n", current_task_user);
		return rst;
    }

    struct passwd *pw = getpwnam(current_task_user);
    if (pw == NULL) {
        // fprintf(stderr, "Error: no such user '%s'\n", current_task_user);
		return rst;
    }
    uid_t uid = pw->pw_uid;
    // printf("UID for user '%s' is %d\n", current_task_user, uid);

	seteuid(uid);

	rst = fstatat(__fd, __file, __buf, __flag);

   if (seteuid(getuid()) == -1) {
        // fprintf(stderr, "Error: rollback to original uid failed'\n");
    }
	return rst;
}
